<?php
#########################################################
############### AUDIT LOG FUNCTIONS #####################
#########################################################

####### GET TABLE DATA BEFORE ANY CHANGES ########

function table_before_change($TableName, $currentID, $tableID) {
$_SESSION['before_change_sql'] ="";
$fet=sql("SELECT * FROM $TableName WHERE $tableID = $currentID", $eo);
$row = db_fetch_row($fet);
// STORE THEM IN A SESSION VARIABLE FOR LATER COMPARISON
$row = str_replace("\n", "<br/>", $row);
$row = str_replace("'", "\'", $row);
$_SESSION ['before_change_sql'] = $row; 

return;
}


### GET CHANGES AND ADD TO AUDIT LOG ###

function table_after_change($db_name, $TableName, $username, $userIP, $currentID, $tableID, $type){

// GET ALL COLUMN NAMES IN THE TABLE
/*
$colnames = array(); // Create Empty Array
$colquery =sql("SELECT `COLUMN_NAME` FROM `INFORMATION_SCHEMA`.`COLUMNS` WHERE `TABLE_SCHEMA`='$db_name' AND `TABLE_NAME`='$TableName'", $eo);

$i = 0;
while ($row = db_fetch_array($colquery)) {
foreach($row as $key => $val) {
$colnames[$i] = $val; }
$i++; }
*/
$colnames = array();$i = 0;
           $query = sql("SHOW COLUMNS FROM $TableName", $eo);
            while($result = mysqli_fetch_assoc($query)):
                    $colnames[$i] = $result['Field'];
					$i++;
             endwhile;



// GET ARRAY OF VALUES AFTER CHANGE
$_SESSION ['after_change_sql'] ="";
$fet=sql("SELECT * FROM $TableName WHERE $tableID = $currentID", $eo);
$row = db_fetch_row($fet);
$row = str_replace("\n", "<br/>", $row);
$row = str_replace("'", "\'", $row);
$_SESSION ['after_change_sql'] = $row;

// ARRAY OF ORIGINAL VALUES // ARRAY OF UPDATED VALUES
$array1 = $_SESSION ['before_change_sql'];	$array2 = $_SESSION ['after_change_sql'];

####### COMPARE BEFORE AND AFTER VALUES AND ADD CHANGED DATA ENTRIES TO AUDIT LOG #######

$del="-DELETED-";
$i = 0;
for ($i = 0; $i <= count($array1); ++$i) {
if ($array1[$i] != $array2[$i])
{// Adds the INITIAL Values and CHANGED values to the auditlog database table

switch (true) {
// START Examples of how to exclude specific fields from being added to the audit Log
case ($colnames[$i] == "editDate"):
break;

case ($colnames[$i] == "editedBy"):
break;

case ($colnames[$i] == "id_cnote"):
break;

case ($colnames[$i] == "Note"):
break;

case ($colnames[$i] == "fk_res"):
break;
// END of exclusion examples

case ($type == "DELETION"):
sql("INSERT INTO Auditor (res_id, username, ipaddr, time_stmp, change_type, table_name, fieldName, OldValue, NewValue) VALUES ('$currentID', '$username','$userIP',NOW(),'$type','$TableName','$colnames[$i]','$array1[$i]','$del')", $eo);
break;
default:
sql("INSERT INTO Auditor (res_id, username, ipaddr, time_stmp, change_type, table_name, fieldName, OldValue, NewValue) VALUES ('$currentID', '$username','$userIP',NOW(),'$type','$TableName','$colnames[$i]','$array1[$i]','$array2[$i]')", $eo);
break;
}

}
}
unset($_SESSION['before_change_sql']);
unset($_SESSION['after_change_sql']);
return;
}
?>